#include<bits/stdc++.h>
#define int long long
using namespace std;
const int N=1000005,M=25;
int n,q,o[N],p,d[N],lp[N],st[M][N],u[N],st2[M][N];
vector<int>g[N];
void dfs(int x,int fa){
	d[x]=d[fa]+1;
	o[++p]=x;
	u[x]=p;
	for(auto i:g[x]){
		if(i!=fa){
			dfs(i,x);
			o[++p]=x;
		}
	}
}
inline int Max(int x,int y){
	if(d[x]<d[y])return x;
	return y;
}
inline int lca(int x,int y){
	x=u[x],y=u[y];
	if(x>y)swap(x,y);
	int l=lp[y-x+1];
	return Max(st[l][x],st[l][y-(1ll<<l)+1]);
}
inline int qlca(int x,int y){
	int l=lp[y-x+1];
	return lca(st2[l][x],st2[l][y-(1ll<<l)+1]);
}
signed main(){
#ifndef XYZ
	freopen("query.in","r",stdin);
	freopen("query.out","w",stdout);
#endif
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cin>>n;
	for(int i=1;i<n;i++){
		int u,v;
		cin>>u>>v;
		g[u].push_back(v);
		g[v].push_back(u);
	}
	dfs(1,0);
	for(int i=2;i<=max(n,p);i++)lp[i]=lp[i>>1]+1;
	for(int i=1;i<=p;i++)st[0][i]=o[i];
	for(int i=1;(1ll<<i)<=p;i++){
		for(int j=1;j+(1ll<<i)-1<=p;j++){
			st[i][j]=Max(st[i-1][j],st[i-1][j+(1ll<<(i-1))]);
		}
	}
	for(int i=1;i<=n;i++)st2[0][i]=i;
	for(int i=1;(1ll<<i)<=n;i++){
		for(int j=1;j+(1ll<<i)-1<=n;j++){
			st2[i][j]=lca(st2[i-1][j],st2[i-1][j+(1ll<<(i-1))]);
		}
	}
	cin>>q;
	while(q--){
		int x,y,z;
		cin>>x>>y>>z;
		int r=0;
		for(int i=x;i+z-1<=y;i++){
			r=max(r,d[qlca(i,i+z-1)]);
		}
		cout<<r<<'\n';
	}
	return 0;
}

